<script>
  import { afterUpdate } from 'svelte';
  import * as Prism from 'prismjs';

  export let language;
  export let code;
  export let header = '';
  export let smallCodeWindow;
  let eleCodePre;

  afterUpdate(() => {
    Prism.highlightAllUnder(eleCodePre);
  });
</script>

<svelte:head>
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans:400,700" type="text/css" />
  <link
    rel="stylesheet"
    href="https://tutsplus.github.io/syntax-highlighter-demos/highlighters/Prism/prism_okaidia.css"
  />
</svelte:head>

{#if smallCodeWindow}
  <div class="code-window" on:click>
    {#if header !== undefined} <h2>{header}</h2>{/if}
    <!-- This pre/code MUST be right next to each other -->
    <pre bind:this={eleCodePre} class="code-height"><code class="language-{language}">{code}</code></pre>
  </div>
{:else}
  <div>
    {#if header !== undefined} <h2>{header}</h2>{/if}
    <!-- This pre/code MUST be right next to eachother -->
    <pre bind:this={eleCodePre}><code class="language-{language}">{code}</code></pre>
  </div>
{/if}

<style>
  code[class*='language-'],
  pre[class*='language-'] {
    white-space: pre-wrap !important;
    word-break: break-word !important;
  }
  .code-window {
    flex-grow: 1;
  }
  .code-height {
    overflow: hidden;
  }
</style>
